--- a/include/sound/soc.h
+++ b/include/sound/soc.h
@@ -158,6 +158,9 @@ struct snd_soc_clock_info;
 typedef int (*hw_write_t)(void *,const char* ,int);
 typedef int (*hw_read_t)(void *,char* ,int);
 
+typedef int (*hw_write_l3_t)(void *,int, const char* ,int);
+typedef int (*hw_read_l3_t)(void *,int, char* ,int);
+
 extern struct snd_ac97_bus_ops soc_ac97_ops;
 
 /* pcm <-> DAI connect */
@@ -351,6 +354,8 @@ struct snd_soc_codec {
 	int (*write)(struct snd_soc_codec *, unsigned int, unsigned int);
 	hw_write_t hw_write;
 	hw_read_t hw_read;
+	hw_write_l3_t hw_write_l3;
+	hw_read_l3_t hw_read_l3;
 	void *reg_cache;
 	short reg_cache_size;
 	short reg_cache_step;
--- a/sound/soc/codecs/Kconfig
+++ b/sound/soc/codecs/Kconfig
@@ -2,6 +2,10 @@ config SND_SOC_AC97_CODEC
 	tristate
 	depends on SND_SOC
 
+config SND_SOC_UDA1341
+	tristate
+	depends on SND_SOC
+
 config SND_SOC_WM8731
 	tristate
 	depends on SND_SOC
--- a/sound/soc/codecs/Makefile
+++ b/sound/soc/codecs/Makefile
@@ -1,10 +1,12 @@
 snd-soc-ac97-objs := ac97.o
+snd-soc-uda1341-objs := uda1341.o
 snd-soc-wm8731-objs := wm8731.o
 snd-soc-wm8750-objs := wm8750.o
 snd-soc-wm8753-objs := wm8753.o
 snd-soc-wm9712-objs := wm9712.o
 
 obj-$(CONFIG_SND_SOC_AC97_CODEC)	+= snd-soc-ac97.o
+obj-$(CONFIG_SND_SOC_UDA1341)	+= snd-soc-uda1341.o
 obj-$(CONFIG_SND_SOC_WM8731)	+= snd-soc-wm8731.o
 obj-$(CONFIG_SND_SOC_WM8750)	+= snd-soc-wm8750.o
 obj-$(CONFIG_SND_SOC_WM8753)	+= snd-soc-wm8753.o
--- a/sound/soc/s3c24xx/Kconfig
+++ b/sound/soc/s3c24xx/Kconfig
@@ -8,3 +8,8 @@ config SND_S3C24XX_SOC
 
 config SND_S3C24XX_SOC_I2S
 	tristate
+
+config SND_SMDK2440_UDA1341
+	tristate "SoC Audio for SMDK2440 boards with UDA1341 codec"
+	select SND_S3C24XX_SOC_I2S
+	select SND_SOC_UDA1341
--- a/sound/soc/s3c24xx/Makefile
+++ b/sound/soc/s3c24xx/Makefile
@@ -1,6 +1,8 @@
 # S3c24XX Platform Support
 snd-soc-s3c24xx-objs := s3c24xx-pcm.o
 snd-soc-s3c24xx-i2s-objs := s3c24xx-i2s.o
+snd-soc-smdk2440-objs := smdk2440.o
 
 obj-$(CONFIG_SND_S3C24XX_SOC) += snd-soc-s3c24xx.o
 obj-$(CONFIG_SND_S3C24XX_SOC_I2S) += snd-soc-s3c24xx-i2s.o
+obj-$(CONFIG_SND_SMDK2440_UDA1341) += snd-soc-smdk2440.o
